---
title: "FreeBSD 7.1-RELEASE Release Notes"
sidenav: download
---

++++


<h3 class="CORPAUTHOR">The FreeBSD Project</h3>

<p class="COPYRIGHT">Copyright &copy; 2000, 2001, 2002, 2003, 2004, 2005, 2006, 2007,
2008 The FreeBSD Documentation Project</p>

<p class="PUBDATE">$FreeBSD:
release/7.1.0/release/doc/en_US.ISO8859-1/relnotes/article.sgml 186643 2008-12-31
08:07:10Z hrs $<br />
</p>

<div class="LEGALNOTICE"><a id="TRADEMARKS" name="TRADEMARKS"></a>
<p>FreeBSD is a registered trademark of the FreeBSD Foundation.</p>

<p>IBM, AIX, EtherJet, Netfinity, OS/2, PowerPC, PS/2, S/390, and ThinkPad are trademarks
of International Business Machines Corporation in the United States, other countries, or
both.</p>

<p>IEEE, POSIX, and 802 are registered trademarks of Institute of Electrical and
Electronics Engineers, Inc. in the United States.</p>

<p>Intel, Celeron, EtherExpress, i386, i486, Itanium, Pentium, and Xeon are trademarks or
registered trademarks of Intel Corporation or its subsidiaries in the United States and
other countries.</p>

<p>Sparc, Sparc64, SPARCEngine, and UltraSPARC are trademarks of SPARC International, Inc
in the United States and other countries. Products bearing SPARC trademarks are based
upon architecture developed by Sun Microsystems, Inc.</p>

<p>Many of the designations used by manufacturers and sellers to distinguish their
products are claimed as trademarks. Where those designations appear in this document, and
the FreeBSD Project was aware of the trademark claim, the designations have been followed
by the &#8220;&trade;&#8221; or the &#8220;&reg;&#8221; symbol.</p>
</div>

<div>
<div class="ABSTRACT"><a id="AEN26" name="AEN26"></a>
<p>The release notes for FreeBSD 7.1-RELEASE contain a summary of the changes made to the
FreeBSD base system on the 7.1-STABLE development line. This document lists applicable
security advisories that were issued since the last release, as well as significant
changes to the FreeBSD kernel and userland. Some brief remarks on upgrading are also
presented.</p>
</div>
</div>

<hr />
</div>

<div class="TOC">
<dl>
<dt><b>Table of Contents</b></dt>

<dt>1 <a href="#INTRO">Introduction</a></dt>

<dt>2 <a href="#NEW">What's New</a></dt>

<dd>
<dl>
<dt>2.1 <a href="#SECURITY">Security Advisories</a></dt>

<dt>2.2 <a href="#KERNEL">Kernel Changes</a></dt>

<dd>
<dl>
<dt>2.2.1 <a href="#BOOT">Boot Loader Changes</a></dt>

<dt>2.2.2 <a href="#PROC">Hardware Support</a></dt>

<dt>2.2.3 <a href="#NET-PROTO">Network Protocols</a></dt>

<dt>2.2.4 <a href="#DISKS">Disks and Storage</a></dt>

<dt>2.2.5 <a href="#FS">File Systems</a></dt>
</dl>
</dd>

<dt>2.3 <a href="#USERLAND">Userland Changes</a></dt>

<dd>
<dl>
<dt>2.3.1 <a href="#RC-SCRIPTS"><tt class="FILENAME">/etc/rc.d</tt> Scripts</a></dt>
</dl>
</dd>

<dt>2.4 <a href="#CONTRIB">Contributed Software</a></dt>

<dt>2.5 <a href="#RELENG">Release Engineering and Integration</a></dt>
</dl>
</dd>

<dt>3 <a href="#UPGRADE">Upgrading from previous releases of FreeBSD</a></dt>
</dl>
</div>

<div class="SECT1">
<h2 class="SECT1"><a id="INTRO" name="INTRO">1 Introduction</a></h2>

<p>This document contains the release notes for FreeBSD 7.1-RELEASE. It describes
recently added, changed, or deleted features of FreeBSD. It also provides some notes on
upgrading from previous versions of FreeBSD.</p>

<p>This distribution of FreeBSD 7.1-RELEASE is a release distribution. It can be found at
<a href="ftp://ftp.FreeBSD.org/" target="_top">ftp://ftp.FreeBSD.org/</a> or any of its
mirrors. More information on obtaining this (or other) release distributions of FreeBSD
can be found in the <a href="../../../../doc/en_US.ISO8859-1/books/handbook/mirrors.html"
target="_top">&#8220;Obtaining FreeBSD&#8221; appendix</a> to the <a
href="../../../../doc/en_US.ISO8859-1/books/handbook/" target="_top">FreeBSD
Handbook</a>.</p>

<p>All users are encouraged to consult the release errata before installing FreeBSD. The
errata document is updated with &#8220;late-breaking&#8221; information discovered late
in the release cycle or after the release. Typically, it contains information on known
bugs, security advisories, and corrections to documentation. An up-to-date copy of the
errata for FreeBSD 7.1-RELEASE can be found on the FreeBSD Web site.</p>
</div>

<div class="SECT1">
<hr />
<h2 class="SECT1"><a id="NEW" name="NEW">2 What's New</a></h2>

<p>This section describes the most user-visible new or changed features in FreeBSD since
7.0-RELEASE.</p>

<p>Typical release note items document recent security advisories issued after
7.0-RELEASE, new drivers or hardware support, new commands or options, major bug fixes,
or contributed software upgrades. They may also list changes to major ports/packages or
release engineering practices. Clearly the release notes cannot list every single change
made to FreeBSD between releases; this document focuses primarily on security advisories,
user-visible changes, and major architectural improvements.</p>

<div class="SECT2">
<hr />
<h3 class="SECT2"><a id="SECURITY" name="SECURITY">2.1 Security Advisories</a></h3>

<p>Problems described in the following security advisories have been fixed. For more
information, consult the individual advisories available from <a
href="http://security.FreeBSD.org/" target="_top">http://security.FreeBSD.org/</a>.</p>

<div class="INFORMALTABLE"><a id="AEN46" name="AEN46"></a>
<table border="0" frame="void" class="CALSTABLE">
<col width="1*" />
<col width="1*" />
<col width="3*" />
<thead>
<tr>
<th>Advisory</th>
<th>Date</th>
<th>Topic</th>
</tr>
</thead>

<tbody>
<tr>
<td><a href="http://security.freebsd.org/advisories/FreeBSD-SA-08:05.openssh.asc"
target="_top">SA-08:05.openssh</a></td>
<td>17&nbsp;April&nbsp;2008</td>
<td>
<p>OpenSSH X11-forwarding privilege escalation</p>
</td>
</tr>

<tr>
<td><a href="http://security.freebsd.org/advisories/FreeBSD-SA-08:06.bind.asc"
target="_top">SA-08:06.bind</a></td>
<td>13&nbsp;July&nbsp;2008</td>
<td>
<p>DNS cache poisoning</p>
</td>
</tr>

<tr>
<td><a href="http://security.freebsd.org/advisories/FreeBSD-SA-08:07.amd64.asc"
target="_top">SA-08:07.amd64</a></td>
<td>3&nbsp;September&nbsp;2008</td>
<td>
<p>amd64 swapgs local privilege escalation</p>
</td>
</tr>

<tr>
<td><a href="http://security.freebsd.org/advisories/FreeBSD-SA-08:08.nmount.asc"
target="_top">SA-08:08.nmount</a></td>
<td>3&nbsp;September&nbsp;2008</td>
<td>
<p><a
href="http://www.FreeBSD.org/cgi/man.cgi?query=nmount&sektion=2&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">nmount</span>(2)</span></a> local
arbitrary code execution</p>
</td>
</tr>

<tr>
<td><a href="http://security.freebsd.org/advisories/FreeBSD-SA-08:09.icmp6.asc"
target="_top">SA-08:09.icmp6</a></td>
<td>3&nbsp;September&nbsp;2008</td>
<td>
<p>Remote kernel panics on IPv6 connections</p>
</td>
</tr>

<tr>
<td><a href="http://security.freebsd.org/advisories/FreeBSD-SA-08:10.nd6.asc"
target="_top">SA-08:10.nd6</a></td>
<td>1&nbsp;October&nbsp;2008</td>
<td>
<p>IPv6 Neighbor Discovery Protocol routing vulnerability</p>
</td>
</tr>

<tr>
<td><a href="http://security.freebsd.org/advisories/FreeBSD-SA-08:11.arc4random.asc"
target="_top">SA-08:11.arc4random</a></td>
<td>24&nbsp;November&nbsp;2008</td>
<td>
<p><a
href="http://www.FreeBSD.org/cgi/man.cgi?query=arc4random&sektion=9&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">arc4random</span>(9)</span></a>
predictable sequence vulnerability</p>
</td>
</tr>

<tr>
<td><a href="http://security.freebsd.org/advisories/FreeBSD-SA-08:12.ftpd.asc"
target="_top">SA-08:12.ftpd</a></td>
<td>23&nbsp;December&nbsp;2008</td>
<td>
<p>Cross-site request forgery in <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ftpd&sektion=8&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ftpd</span>(8)</span></a></p>
</td>
</tr>

<tr>
<td><a href="http://security.freebsd.org/advisories/FreeBSD-SA-08:13.protosw.asc"
target="_top">SA-08:13.protosw</a></td>
<td>23&nbsp;December&nbsp;2008</td>
<td>
<p>netgraph / bluetooth privilege escalation</p>
</td>
</tr>
</tbody>
</table>
</div>
</div>

<div class="SECT2">
<hr />
<h3 class="SECT2"><a id="KERNEL" name="KERNEL">2.2 Kernel Changes</a></h3>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=clock_gettime&sektion=2&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">clock_gettime</span>(2)</span></a>
and the related system calls now support a clock ID <tt
class="LITERAL">CLOCK_THREAD_CPUTIME_ID</tt>, defined in POSIX.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=cpuset&sektion=2&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">cpuset</span>(2)</span></a> system
call has been added. This is an API for thread to CPU binding and CPU resource grouping
and assignment.</p>

<p>The DTrace, a comprehensive dynamic tracing framework and <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=dtrace&sektion=1&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">dtrace</span>(1)</span></a>
userland utility have been imported from OpenSolaris. DTrace provides a powerful
infrastructure to permit administrators, developers, and service personnel to concisely
answer arbitrary questions about the behavior of the operating system and user
programs.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ddb&sektion=4&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ddb</span>(4)</span></a> kernel
debugger now has an output capture facility. Input and output from <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ddb&sektion=4&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ddb</span>(4)</span></a> can now
be captured to a memory buffer for later inspection using <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sysctl&sektion=8&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">sysctl</span>(8)</span></a> or a
textdump. The new <tt class="COMMAND">capture</tt> command controls this feature.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ddb&sektion=4&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ddb</span>(4)</span></a> debugger
now supports a simple scripting facility, which supports a set of named scripts
consisting of a set of <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ddb&sektion=4&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ddb</span>(4)</span></a> commands.
These commands can be managed from within <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ddb&sektion=4&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ddb</span>(4)</span></a> or with
the use of the new <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ddb&sektion=8&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ddb</span>(8)</span></a> utility.
More details can be found in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ddb&sektion=4&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ddb</span>(4)</span></a> manual
page.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ddb&sektion=4&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ddb</span>(4)</span></a> <tt
class="COMMAND">ex</tt> command now supports an <code class="OPTION">/S</code> mode which
interprets and prints the value at the requested address as a symbol. For example, <kbd
class="USERINPUT">ex /S <tt class="REPLACEABLE"><i>aio_swake</i></tt></kbd> prints the
name of the function currently registered in via <tt
class="REPLACEABLE"><i>aio_swake</i></tt> hook.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ddb&sektion=4&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ddb</span>(4)</span></a> <tt
class="COMMAND">show conifhk</tt> command has been added. This lists hooks currently
waiting for completion in <code
class="FUNCTION">run_interrupt_driven_config_hooks()</code>.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=fcntl&sektion=2&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">fcntl</span>(2)</span></a> system
call now supports <tt class="LITERAL">F_DUP2FD</tt> command. This is equivalent to <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=dup&sektion=2&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">dup</span>(2)</span></a>, and
compatible with Sun Solaris and IBM AIX.</p>

<p>The FreeBSD's <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=linux&sektion=4&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">linux</span>(4)</span></a> ABI
support now implements <code class="FUNCTION">sched_setaffinity()</code> and <code
class="FUNCTION">get_setaffinity()</code> using real CPU affinity setting primitives.</p>

<p>The client side functionality of <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=rpc.lockd&sektion=8&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">rpc.lockd</span>(8)</span></a> has
been implemented in FreeBSD kernel. This implementation provides the correct semantics
for <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=flock&sektion=2&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">flock</span>(2)</span></a> style
locks which are used by the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=lockf&sektion=1&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">lockf</span>(1)</span></a> command
line tool and the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=pidfile&sektion=3&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">pidfile</span>(3)</span></a>
library. It also implements recovery from server restarts and ensures that dirty cache
blocks are written to the server before obtaining locks (allowing multiple clients to use
file locking to safely share data). Also, a new kernel option <tt class="LITERAL">options
NFSLOCKD</tt> has been added and enabled by default. If the kernel support is enabled, <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=rpc.lockd&sektion=8&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">rpc.lockd</span>(8)</span></a>
automatically detects and uses the functionality.</p>

<p>The FreeBSD kernel now supports a new textdump format of kernel dumps. A textdump
provides higher-level information via mechanically generated/extracted debugging output,
rather than a simple memory dump. This facility can be used to generate brief kernel bug
reports that are rich in debugging information, but are not dependent on kernel symbol
tables or precisely synchronized source code. More information can be found in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=textdump&sektion=4&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">textdump</span>(4)</span></a>
manual page.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=wait4&sektion=2&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">wait4</span>(2)</span></a> system
call now supports <code class="OPTION">WNOWAIT</code> flag to keep the process whose
status is returned in a waitable state and <code class="OPTION">WSTOPPED</code> which is
equivalent to <code class="OPTION">WUNTRACED</code>.</p>

<p>[amd64, i386, sparc64] The FreeBSD kernel now supports initial support of binding
interrupts to CPUs.</p>

<p>[amd64, i386] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sched_ule&sektion=4&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">sched_ule</span>(4)</span></a>
scheduler is now the default process scheduler in <tt class="FILENAME">GENERIC</tt>
kernels.</p>

<p>The sysctl variables <code class="VARNAME">kern.features.compat_freebsd[456]</code>
have been added. These are corresponding to the kernel options <tt
class="LITERAL">COMPAT_FREEBSD[456]</tt>.</p>

<div class="SECT3">
<hr />
<h4 class="SECT3"><a id="BOOT" name="BOOT">2.2.1 Boot Loader Changes</a></h4>

<p>[amd64, i386] The BTX kernel used by the boot loader has been changed to invoke BIOS
routines from real mode. This change makes it possible to boot FreeBSD from USB
devices.</p>

<p>[amd64, i386] A new gptboot boot loader has been added to support booting from a GPT
labeled disk. A new <tt class="COMMAND">boot</tt> command has been added to <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=gpt&sektion=8&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">gpt</span>(8)</span></a>, which
makes a GPT disk bootable by writing the required bits of the boot loader, creating a new
boot partition if required.</p>
</div>

<div class="SECT3">
<hr />
<h4 class="SECT3"><a id="PROC" name="PROC">2.2.2 Hardware Support</a></h4>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=cmx&sektion=4&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">cmx</span>(4)</span></a> driver, a
driver for Omnikey CardMan 4040 PCMCIA smartcard readers, has been added.</p>

<p>[sparc64] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=kbdmux&sektion=4&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">kbdmux</span>(4)</span></a> driver
has been added. The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sunkbd&sektion=4&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">sunkbd</span>(4)</span></a> now
supports <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=atkbd&sektion=4&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">atkbd</span>(4)</span></a>
emulation like <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ukbd&sektion=4&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ukbd</span>(4)</span></a>.</p>

<p>The <tt class="FILENAME">nvram(4)</tt> driver is now MPSAFE.</p>

<p>An option of the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=puc&sektion=4&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">puc</span>(4)</span></a> driver
<tt class="LITERAL">PUC_FASTINTR</tt> has been no longer supported.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=psm&sektion=4&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">psm</span>(4)</span></a> driver
now attempts detection of Synaptics touchpad before IntelliMouse. Some touchpads will
pretend to be IntelliMouse causing the IntelliMouse probe to work and the Synaptics
detection never to be done.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=uslcom&sektion=4&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">uslcom</span>(4)</span></a>
driver, a driver for Silicon Laboratories CP2101/CP2102-based USB serial adapters, has
been imported from OpenBSD.</p>

<div class="SECT4">
<hr />
<h5 class="SECT4"><a id="MM" name="MM">2.2.2.1 Multimedia Support</a></h5>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=agp&sektion=4&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">agp</span>(4)</span></a> driver
now supports Intel G33 and G45.</p>

<p>[i386] The <tt class="FILENAME">dpms(4)</tt> driver has been added to use the VESA
BIOS for DPMS during suspend and resume.</p>

<p>The <b class="APPLICATION">DRM</b> kernel driver now supports i915 GME devices.</p>
</div>

<div class="SECT4">
<hr />
<h5 class="SECT4"><a id="NET-IF" name="NET-IF">2.2.2.2 Network Interface Support</a></h5>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ale&sektion=4&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ale</span>(4)</span></a> driver
has been added to provide support for Atheros AR8121/AR8113/AR8114 Gigabit/Fast Ethernet
controllers. This driver is not enabled in <tt class="FILENAME">GENERIC</tt> kernels for
this release.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=em&sektion=4&manpath=FreeBSD+7.1-RELEASE"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">em</span>(4)</span></a> driver has been
split into two drivers with some common parts. The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=em&sektion=4&manpath=FreeBSD+7.1-RELEASE"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">em</span>(4)</span></a> driver will
continue to support adapters up to the 82575, as well as new client/desktop adapters. A
new <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=igb&sektion=4&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">igb</span>(4)</span></a> driver
will support new server adapters.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=hme&sektion=4&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">hme</span>(4)</span></a> driver
has been improved.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ixgbe&sektion=4&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ixgbe</span>(4)</span></a> driver
has been updated to version 1.6.2 from Intel.</p>

<p>A bug in some of the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=miibus&sektion=4&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">miibus</span>(4)</span></a>
supported drivers that IEEE 802.3 auto-negotiation was performed in a wrong order, has
been fixed. Now it chooses the correct technologies supported by IEEE 802.3 in the order
described in Annex 28B.3.</p>

<p>A workaround has been added for a bug in TCP/UDP hardware checksum offload of the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=msk&sektion=4&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">msk</span>(4)</span></a> driver
for short frames. Note that for frames that requires hardware VLAN tag insertion, the
checksum offload workaround does not work due to changes of checksum offset in mbuf after
the VLAN tag. So disabling hardware checksum offload for the VLAN interface is needed in
such cases.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ndis&sektion=4&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ndis</span>(4)</span></a> NDIS
miniport driver wrapper has been improved.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sf&sektion=4&manpath=FreeBSD+7.1-RELEASE"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">sf</span>(4)</span></a> driver has been
improved and now supports checksum offloading.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=stge&sektion=4&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">stge</span>(4)</span></a> driver
now supports WOL (Wake on LAN).</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=vr&sektion=4&manpath=FreeBSD+7.1-RELEASE"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">vr</span>(4)</span></a> driver has been
improved.</p>

<p>[amd64, i386] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=wpi&sektion=4&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">wpi</span>(4)</span></a> driver
has been updated to include a number of stability fixes.</p>
</div>
</div>

<div class="SECT3">
<hr />
<h4 class="SECT3"><a id="NET-PROTO" name="NET-PROTO">2.2.3 Network Protocols</a></h4>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=arp&sektion=8&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">arp</span>(8)</span></a> utility
now supports <tt class="LITERAL">reject</tt> and <tt class="LITERAL">blackhole</tt>
keywords. In the entry marked as <tt class="LITERAL">reject</tt>, traffic to the host
will be discarded and the sender will be notified the host is unreachable. In the entry
marked as <tt class="LITERAL">blackhole</tt>, traffic is discarded but the sender is not
notified.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=bpf&sektion=4&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">bpf</span>(4)</span></a> now
supports an ioctl <tt class="LITERAL">BIOCSETFNR</tt>. This is just like <tt
class="LITERAL">BIOCSETF</tt> but it does not drop all the packets buffered on the
descriptor and reset the statistics.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=if_bridge&sektion=4&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">if_bridge</span>(4)</span></a> now
allow to limit the number of source MACs that can be behind a bridge interface via <tt
class="LITERAL">ifmaxaddr</tt> parameter of <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ifconfig&sektion=8&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ifconfig</span>(8)</span></a>.</p>

<p>A bug in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=carp&sektion=4&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">carp</span>(4)</span></a>
interface configuration which leads to a system panic has been fixed.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=dummynet&sektion=4&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">dummynet</span>(4)</span></a>
subsystem now supports <tt class="LITERAL">fast</tt> mode operation which allows certain
packets to bypass the dummynet scheduler. This can achieve lower latency and lower
overhead when the packet flow is under the pipe bandwidth, and eliminate recursion in the
subsystem. The new sysctl variable <code
class="VARNAME">net.inet.ip.dummynet.io_fast</code> has been added to enable this
feature.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=enc&sektion=4&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">enc</span>(4)</span></a> now
supports sysctl variables to control whether the firewalls or <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=bpf&sektion=4&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">bpf</span>(4)</span></a> will see
inner and outer headers or just inner or outer headers for incoming and outgoing IPsec
packets.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=gre&sektion=4&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">gre</span>(4)</span></a> now
supports ioctls <tt class="LITERAL">GRESKEY</tt> and <tt class="LITERAL">GREGKEY</tt>
which allows set or get GRE key used for outgoing packets.</p>

<p>A bug in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ipsec&sektion=4&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ipsec</span>(4)</span></a>
subsystem that PMTU was broken in those cases when there was a route with a lower MTU
than the MTU of the outgoing interface, has been fixed.</p>

<p>The netatm subsystem has been removed due to lacking of multiprocessor support.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ng_nat&sektion=4&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ng_nat</span>(4)</span></a> now
supports redirect functionality in <tt class="FILENAME">libalias</tt>. For more details,
see the manual page.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ng_pptpgre&sektion=4&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ng_pptpgre</span>(4)</span></a>
now supports multiple hooks like <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ng_l2tp&sektion=4&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ng_l2tp</span>(4)</span></a>, to
use one pair of pptpgre and ksocket nodes for all calls between two peers.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=resolver&sektion=3&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">resolver</span>(3)</span></a> now
allows underscore in domain names. Although this is a violation of RFC 1034 [STD 13], it
is accepted by certain name servers as well as other popular operating systems' resolver
library.</p>

<p>A socket option <tt class="LITERAL">TCP_CONGESTION</tt> for TCP socket has been added.
This is for setting and retrieving the congestion control algorithm. The name used is to
allow compatibility with Linux.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=rwlock&sektion=9&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">rwlock</span>(9)</span></a> has
been used throughout the <code class="VARNAME">inpcbinfo</code> and <code
class="VARNAME">inpcb</code> infrastructure, and protocols that depend on that
infrastructure, including UDP, TCP, and IP raw sockets to reduce the lock
contentions.</p>
</div>

<div class="SECT3">
<hr />
<h4 class="SECT3"><a id="DISKS" name="DISKS">2.2.4 Disks and Storage</a></h4>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=aac&sektion=4&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">aac</span>(4)</span></a> driver
now supports 64-bit array support for RAIDs larger than 2TB and simultaneous opens of the
device for issuing commands to the controller.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ata&sektion=4&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ata</span>(4)</span></a> driver
now supports a loader variable <code class="VARNAME">hw.ata.ata_dma_check_80pin</code>.
This can be used to disable the 80pin cable check on broken systems such as certain
laptops and Soekris boards. The default value is <tt class="LITERAL">1</tt>.</p>

<p>A data corruption problem of the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ata&sektion=4&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ata</span>(4)</span></a> driver on
ServerWorks HT1000 chipsets has been fixed.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ciss&sektion=4&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ciss</span>(4)</span></a> driver
now supports a loader tunable <code class="VARNAME">hw.ciss.nop_message_heartbeat</code>
for NOP-message polling in <code class="FUNCTION">ciss_periodic()</code>. This can be
used as a workaround for <tt class="LITERAL">ADAPTER HEARTBEAT FAILED</tt> issue. The
default value is <tt class="LITERAL">0</tt> (disabled).</p>

<p>The <tt class="FILENAME">geom_part</tt> GEOM class can be built as a kernel
module.</p>

<p>The <tt class="FILENAME">geom_linux_lvm</tt> GEOM class can be built as a kernel
module.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=hptrr&sektion=4&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">hptrr</span>(4)</span></a> driver
has been updated to version 1.2 from Highpoint.</p>

<p>A buffer overflow in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=iir&sektion=4&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">iir</span>(4)</span></a> driver
has been fixed. This likely fixes a great number of weird problems that have been
reported with this driver.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=mpt&sektion=4&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">mpt</span>(4)</span></a> driver
now supports <tt class="LITERAL">mpt_user</tt> personality.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=rr232x&sektion=4&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">rr232x</span>(4)</span></a> driver
has been superseded by <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=hptrr&sektion=4&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">hptrr</span>(4)</span></a>
driver.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=twa&sektion=4&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">twa</span>(4)</span></a> driver
has been improved with regard to stability on machines with a plenty of memory and high
CPU load.</p>
</div>

<div class="SECT3">
<hr />
<h4 class="SECT3"><a id="FS" name="FS">2.2.5 File Systems</a></h4>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=fdescfs&sektion=5&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">fdescfs</span>(5)</span></a> is
now MPSAFE.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=gpart&sektion=8&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">gpart</span>(8)</span></a> now
supports BSD disklabels (option <tt class="LITERAL">GEOM_PART_BSD</tt>) and VTOC8
disklabels (option <tt class="LITERAL">GEOM_PART_VTOC8</tt>).</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=gvinum&sektion=8&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">gvinum</span>(8)</span></a> now
accepts <tt class="REPLACEABLE"><i>volume</i></tt> parameter when creating a plex.</p>

<p>A pathname lookup bug of a UNIX domain socket in the <tt
class="FILENAME">unionfs(7)</tt> has been fixed.</p>
</div>
</div>

<div class="SECT2">
<hr />
<h3 class="SECT2"><a id="USERLAND" name="USERLAND">2.3 Userland Changes</a></h3>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=adduser&sektion=8&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">adduser</span>(8)</span></a>
utility now supports a <code class="OPTION">-M</code> option to set the mode of a new
user's home directory.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=atacontrol&sektion=8&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">atacontrol</span>(8)</span></a>
utility now supports a <tt class="COMMAND">spindown</tt> command to set or report timeout
after which the device will be spun down.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=chflags&sektion=1&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">chflags</span>(1)</span></a> now
supports a <code class="OPTION">-v</code> flag for verbose output, a <code
class="OPTION">-f</code> flag to ignore errors, and <code class="OPTION">-h</code> to
allow setting flags on symbolic links with the same semantics as (for example) <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=chmod&sektion=1&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">chmod</span>(1)</span></a>.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=cp&sektion=1&manpath=FreeBSD+7.1-RELEASE"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">cp</span>(1)</span></a> now supports a
<code class="OPTION">-a</code> flag, which is equivalent to <code
class="OPTION">-RpP</code> flags.</p>

<p>A bug in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=cp&sektion=1&manpath=FreeBSD+7.1-RELEASE"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">cp</span>(1)</span></a> utility which
prevents POSIX.1e ACL (see also <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=acl&sektion=3&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">acl</span>(3)</span></a>) from
copying properly has been fixed.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=cron&sektion=8&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">cron</span>(8)</span></a> utility
now supports <code class="OPTION">-m</code> flag which overrides the default mail
recipient for cron mails unless explicitly provided by <tt class="LITERAL">MAILTO=</tt>
line in <tt class="FILENAME">crontab</tt> file.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=dhclient&sektion=8&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">dhclient</span>(8)</span></a> now
supports more options described in <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=dhcp-options&sektion=5&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span
class="REFENTRYTITLE">dhcp-options</span>(5)</span></a>.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=dhclient&sektion=8&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">dhclient</span>(8)</span></a> now
supports <code class="FUNCTION">is_default_interface()</code> function which determines
if this interface is one with the default route.</p>

<p>A bug in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=dhclient&sektion=8&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">dhclient</span>(8)</span></a> that
prevents removal of the default route from working has been fixed.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=environ&sektion=7&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">environ</span>(7)</span></a>,
environment array of strings now supports unsetting a variable by setting the first
character to NULL. This is required by third-party software such as <b
class="APPLICATION">Dovecot</b> and <b class="APPLICATION">Postfix</b>.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=fdisk&sektion=8&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">fdisk</span>(8)</span></a> now
supports a <code class="OPTION">-q</code> flag to not display any warnings.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=fetch&sektion=1&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">fetch</span>(1)</span></a> program
and <tt class="FILENAME">libfetch</tt> library now supports a <code
class="VARNAME">NO_PROXY</code> environment variable. This specifies comma- or
whitespace-separated list of host names for which proxies should not be used. If a single
asterisk is specified, the use of proxies is disabled.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ffsll&sektion=3&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ffsll</span>(3)</span></a> and <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=flsll&sektion=3&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">flsll</span>(3)</span></a>
functions have been added. These functions are the same as <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ffs&sektion=3&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ffs</span>(3)</span></a> and <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=fls&sektion=3&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">fls</span>(3)</span></a> except
that they accept long long as the arguments.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=fortune&sektion=6&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">fortune</span>(6)</span></a>
program now supports <code class="VARNAME">FORTUNE_PATH</code> environment variable to
specify search path of the fortune files.</p>

<p>A bug in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=fortune&sektion=6&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">fortune</span>(6)</span></a>
program that prevents <code class="OPTION">-e</code> option with multiple files from
working has been fixed.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=freebsd-update.conf&sektion=5&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span
class="REFENTRYTITLE">freebsd-update.conf</span>(5)</span></a> now supports <tt
class="LITERAL">IDSIgnorePaths</tt> statement.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=fwcontrol&sektion=8&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">fwcontrol</span>(8)</span></a>
utility now supports <code class="OPTION">-f <tt
class="REPLACEABLE"><i>node</i></tt></code> option which specifies <tt
class="REPLACEABLE"><i>node</i></tt> as the root node on the next bus reset.</p>

<p>[sparc64] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=gcc&sektion=1&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">gcc</span>(1)</span></a> now
accepts <code class="OPTION">-mcpu</code> option properly; it was hardcoded as <code
class="OPTION">-mcpu=ultrasparc</code>.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=gpt&sektion=8&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">gpt</span>(8)</span></a> now
supports ZFS.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ifconfig&sektion=8&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ifconfig</span>(8)</span></a> now
supports display of WPS IE (Wireless Provisioning Services Information Element).</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=kgdb&sektion=1&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">kgdb</span>(1)</span></a> now
supports an <tt class="COMMAND">add-kld <tt class="REPLACEABLE"><i>kld</i></tt></tt>
command to locate a <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=kld&sektion=4&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">kld</span>(4)</span></a> and load
its symbols.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=kgdb&sektion=1&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">kgdb</span>(1)</span></a> now has
a shared library backend for kernel files that treats <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=kld&sektion=4&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">kld</span>(4)</span></a> as shared
libraries and auto-loading symbols for <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=kld&sektion=4&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">kld</span>(4)</span></a> on
startup.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=kgdb&sektion=1&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">kgdb</span>(1)</span></a> now
supports a <tt class="COMMAND">tid</tt> command and other kernel module related commands
even for a remote target.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=kvm_getcptime&sektion=3&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">kvm_getcptime</span>(3)</span></a>
function to obtain the global CPU time statistics from the kernel has been added.</p>

<p>The <tt class="FILENAME">libalias</tt> library now supports <tt
class="LITERAL">PORT</tt> and <tt class="LITERAL">EPRT</tt> FTP commands in
lowercase.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=man&sektion=1&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">man</span>(1)</span></a> now
includes a limited support of <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=bzip2&sektion=1&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span
class="REFENTRYTITLE">bzip2</span>(1)</span></a>-compressed manual pages.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=mdconfig&sektion=8&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">mdconfig</span>(8)</span></a> now
supports a <code class="OPTION">-v</code> (verbose) flag to <code
class="OPTION">-l</code> command. It shows size and backing store of all <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=md&sektion=4&manpath=FreeBSD+7.1-RELEASE"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">md</span>(4)</span></a> devices at one
time.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=memrchr&sektion=3&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">memrchr</span>(3)</span></a>
function has been added. This behaves like <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=memchr&sektion=3&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">memchr</span>(3)</span></a> except
that it locates the last occurrence of the specified character in the string.</p>

<p>The incorrect output grammar of <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=morse&sektion=6&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">morse</span>(6)</span></a> program
has been fixed.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=mountd&sektion=8&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">mountd</span>(8)</span></a>
utility now supports <code class="OPTION">-h <tt
class="REPLACEABLE"><i>bindip</i></tt></code> option which specifies IP addresses to bind
to for TCP and UDP requests. This option may be specified multiple times. If no <code
class="OPTION">-h</code> option is specified, <tt class="LITERAL">INADDR_ANY</tt> will be
used. Note that when specifying IP addresses with this option, it will automatically add
<tt class="LITERAL">127.0.0.1</tt> and if IPv6 is enabled, <tt class="LITERAL">::1</tt>
to the list.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=moused&sektion=8&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">moused</span>(8)</span></a>
utility now supports <code class="OPTION">-L</code> flag which changes the speed of
scrolling and changes <code class="OPTION">-U</code> option behavior to only affect the
scroll threshold.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=mv&sektion=1&manpath=FreeBSD+7.1-RELEASE"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">mv</span>(1)</span></a> now support
POSIX specification when moving a directory to an existing directory across devices.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=periodic&sektion=8&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">periodic</span>(8)</span></a> now
supports <code class="VARNAME">daily_status_mail_rejects_shorten</code> configuration
variable in <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=periodic.conf&sektion=5&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span
class="REFENTRYTITLE">periodic.conf</span>(5)</span></a>. This allows the rejected mail
reports to tally the rejects per blacklist without providing details about individual
sender hosts. The default configuration keeps the reports in their original form.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ping6&sektion=8&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ping6</span>(8)</span></a> now
uses exit status of <tt class="LITERAL">0</tt> and <tt class="LITERAL">2</tt> in the same
manner as <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ping&sektion=8&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ping</span>(8)</span></a>.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ping6&sektion=8&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ping6</span>(8)</span></a> now
supports an <code class="OPTION">-o</code> flag, which makes <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ping6&sektion=8&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ping6</span>(8)</span></a> exit
successfully after receiving one reply packet.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ping6&sektion=8&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ping6</span>(8)</span></a> now
supports <code class="OPTION">-r</code> and <code class="OPTION">-R</code> flags, which
are equivalent to <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ping&sektion=8&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ping</span>(8)</span></a>'s <code
class="OPTION">-a</code> and <code class="OPTION">-A</code> flags, respectively.</p>

<p>The minimum allowed interval of <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ping6&sektion=8&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ping6</span>(8)</span></a> has
been decreased to 0.000001 from 0.01.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=realpath&sektion=1&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">realpath</span>(1)</span></a>
utility now supports a <code class="OPTION">-q</code> flag to suppress warnings; it now
also accepts multiple paths on its command line.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=rfcomm_pppd&sektion=8&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">rfcomm_pppd</span>(8)</span></a>
now supports a <code class="OPTION">-D</code> flag to register DUN (Dial-Up Networking)
service in addition to the LAN (LAN Access Using PPP) service.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sdpd&sektion=8&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">sdpd</span>(8)</span></a> now
supports a <tt class="LITERAL">NAP</tt>, <tt class="LITERAL">GN</tt>, and <tt
class="LITERAL">PANU</tt> profiles.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=setkey&sektion=8&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">setkey</span>(8)</span></a>
utility now accepts <tt class="LITERAL">esp</tt> as a protocol name for the <tt
class="COMMAND">spdadd</tt> command.</p>

<p>A bug in <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=telnetd&sektion=8&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">telnetd</span>(8)</span></a> that
it attempts authentication even when <code class="OPTION">-a off</code> option is
specified has been fixed.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=top&sektion=1&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">top</span>(1)</span></a> and <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=vmstat&sektion=8&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">vmstat</span>(8)</span></a> now
support <code class="OPTION">-P</code> flag which displays per-CPU statistics.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=traceroute&sektion=8&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">traceroute</span>(8)</span></a>
now supports an <code class="OPTION">-a</code> flag to display AS number corresponding to
the lookup IP address on each hop. It will query the number to WHOIS server specified in
<code class="OPTION">-A</code> option. If no <code class="OPTION">-A</code> is specified,
<tt class="HOSTID">whois.radb.net</tt> will be used as the default value.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=uuid_enc_le&sektion=3&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">uuid_enc_le</span>(3)</span></a>,
<a
href="http://www.FreeBSD.org/cgi/man.cgi?query=uuid_dec_le&sektion=3&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">uuid_dec_le</span>(3)</span></a>,
<a
href="http://www.FreeBSD.org/cgi/man.cgi?query=uuid_enc_be&sektion=3&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">uuid_enc_be</span>(3)</span></a>,
and <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=uuid_dec_be&sektion=3&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">uuid_dec_be</span>(3)</span></a>
functions have been added. These functions encode/decode a binary representation of a
UUID.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=watch&sektion=8&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">watch</span>(8)</span></a> utility
now supports more than 10 <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=snp&sektion=4&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">snp</span>(4)</span></a> devices
at a time.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ypserv&sektion=8&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ypserv</span>(8)</span></a> now
supports a <code class="OPTION">-P</code> option to specify the port number on which it
should listen.</p>

<div class="SECT3">
<hr />
<h4 class="SECT3"><a id="RC-SCRIPTS" name="RC-SCRIPTS">2.3.1 <tt
class="FILENAME">/etc/rc.d</tt> Scripts</a></h4>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=rc.conf&sektion=5&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">rc.conf</span>(5)</span></a> now
supports <code class="VARNAME">dummynet_enable</code> variable which allow <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=dummynet&sektion=4&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">dummynet</span>(4)</span></a>
kernel module to be loaded when <code class="VARNAME">firewall_enable</code> is <tt
class="LITERAL">YES</tt>.</p>

<p>The <tt class="FILENAME">ntpd</tt> <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=rc&sektion=8&manpath=FreeBSD+7.1-RELEASE"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">rc</span>(8)</span></a> script can work
with no configuration file <tt class="FILENAME">/etc/ntp.conf</tt> now.</p>

<p>The <tt class="FILENAME">ppp</tt> <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=rc&sektion=8&manpath=FreeBSD+7.1-RELEASE"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">rc</span>(8)</span></a> script now
supports multiple instances. For more details, see description of <code
class="VARNAME">ppp_profile</code> variable in <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=rc.conf&sektion=5&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">rc.conf</span>(5)</span></a>.</p>

<p>The <tt class="FILENAME">sysctl</tt> <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=rc&sektion=8&manpath=FreeBSD+7.1-RELEASE"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">rc</span>(8)</span></a> script now
supports loading <tt class="FILENAME">/etc/sysctl.conf.local</tt> in addition to <tt
class="FILENAME">/etc/sysctl.conf</tt>.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=rc.conf&sektion=5&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">rc.conf</span>(5)</span></a> now
supports configuration of interfaces and attached networks for firewall rule set by <tt
class="FILENAME">rc.firewall</tt> when <code class="VARNAME">firewall_type</code> is <tt
class="LITERAL">simple</tt> or <tt class="LITERAL">client</tt>. See <code
class="VARNAME">firewall_client_net</code>, <code
class="VARNAME">firewall_simple_iif</code>, <code
class="VARNAME">firewall_simple_inet</code>, <code
class="VARNAME">firewall_simple_oif</code>, and <code
class="VARNAME">firewall_simple_onet</code>.</p>
</div>
</div>

<div class="SECT2">
<hr />
<h3 class="SECT2"><a id="CONTRIB" name="CONTRIB">2.4 Contributed Software</a></h3>

<p><b class="APPLICATION">am-utils</b> has been updated from version 6.0.10p1 to version
6.1.5.</p>

<p><b class="APPLICATION">ISC BIND</b> has been updated to version 9.4.2-P2.</p>

<p><b class="APPLICATION">awk</b> has been updated from 1 May 2007 release to the 23
October 2007 release.</p>

<p><b class="APPLICATION">bzip2</b> has been updated from version 1.0.4 to version
1.0.5.</p>

<p><b class="APPLICATION">CVS</b> has been updated to version 1.11.22.1.</p>

<p><b class="APPLICATION">hostapd</b> has been updated to version 0.5.10 + radius ACL
support.</p>

<p><tt class="FILENAME">libarchive</tt> has been updated to version 2.5.5.</p>

<p><b class="APPLICATION">ncurses</b> library has been updated to version
5.6-20080503.</p>

<p><b class="APPLICATION">NTP</b> has been updated to version 4.2.4p5.</p>

<p><b class="APPLICATION">OpenPAM</b> has been updated from the Figwort release to the
Hydrangea release.</p>

<p><b class="APPLICATION">OpenSSH</b> has been updated from version 4.5p1 to version
5.1p1.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=resolver&sektion=3&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">resolver</span>(3)</span></a>
library has been updated to one of <b class="APPLICATION">ISC BIND</b> 9.4.3.</p>

<p><b class="APPLICATION">sendmail</b> has been updated from version 8.14.2 to version
8.14.3.</p>

<p>The timezone database has been updated from the <b class="APPLICATION">tzdata2007h</b>
release to the <b class="APPLICATION">tzdata2008h</b> release.</p>

<p><b class="APPLICATION">wpa_supplicant</b> has been updated to version 0.5.10 + syslog
support.</p>
</div>

<div class="SECT2">
<hr />
<h3 class="SECT2"><a id="RELENG" name="RELENG">2.5 Release Engineering and
Integration</a></h3>

<p>The supported version of the <b class="APPLICATION">GNOME</b> desktop environment (<a
href="http://www.FreeBSD.org/cgi/url.cgi?ports/x11/gnome2/pkg-descr"><tt
class="FILENAME">x11/gnome2</tt></a>) has been updated from 2.20.1 to 2.22.</p>

<p>The supported version of the <b class="APPLICATION">KDE</b> desktop environment (<a
href="http://www.FreeBSD.org/cgi/url.cgi?ports/x11/kde3/pkg-descr"><tt
class="FILENAME">x11/kde3</tt></a>) has been updated from 3.5.8 to 3.5.10.</p>
</div>
</div>

<div class="SECT1">
<hr />
<h2 class="SECT1"><a id="UPGRADE" name="UPGRADE">3 Upgrading from previous releases of
FreeBSD</a></h2>

<p>[amd64, i386] Beginning with FreeBSD 6.2-RELEASE, binary upgrades between RELEASE
versions (and snapshots of the various security branches) are supported using the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=freebsd-update&sektion=8&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span
class="REFENTRYTITLE">freebsd-update</span>(8)</span></a> utility. The binary upgrade
procedure will update unmodified userland utilities, as well as unmodified GENERIC or SMP
kernels distributed as a part of an official FreeBSD release. The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=freebsd-update&sektion=8&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span
class="REFENTRYTITLE">freebsd-update</span>(8)</span></a> utility requires that the host
being upgraded have Internet connectivity.</p>

<p>An older form of binary upgrade is supported through the <tt
class="COMMAND">Upgrade</tt> option from the main <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sysinstall&sektion=8&manpath=FreeBSD+7.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">sysinstall</span>(8)</span></a>
menu on CDROM distribution media. This type of binary upgrade may be useful on non-i386,
non-amd64 machines or on systems with no Internet connectivity.</p>

<p>Source-based upgrades (those based on recompiling the FreeBSD base system from source
code) from previous versions are supported, according to the instructions in <tt
class="FILENAME">/usr/src/UPDATING</tt>.</p>

<div class="IMPORTANT">
<blockquote class="IMPORTANT">
<p><b>Important:</b> Upgrading FreeBSD should, of course, only be attempted after backing
up <span class="emphasis"><i class="EMPHASIS">all</i></span> data and configuration
files.</p>
</blockquote>
</div>
</div>
</div>

<hr />
<p align="center"><small>This file, and other release-related documents, can be
downloaded from <a href="ftp://ftp.FreeBSD.org/">ftp://ftp.FreeBSD.org/</a>.</small></p>

<p align="center"><small>For questions about FreeBSD, read the <a
href="http://www.FreeBSD.org/docs.html">documentation</a> before contacting &#60;<a
href="mailto:questions@FreeBSD.org">questions@FreeBSD.org</a>&#62;.</small></p>

<p align="center"><small>For questions about this documentation, e-mail &#60;<a
href="mailto:doc@FreeBSD.org">doc@FreeBSD.org</a>&#62;.</small></p>
++++


